;;; prioritaetswarteschlange_a_stern.scm
;;; Stellt die zur Verwaltung einer Prioritaetswarteschlange
;;; notwendigen Funktionen bereit.
;;; Benoetigt ein Vergleichspraedikat vor?, das hier
;;; angepasst an das Problem mit dem Parameter ziel realisiert ist.

;;; ===== vor? =====
;;;(define (vor? kante-1 kante-2 ziel)
;;;   'undefiniert)

;;; ===== fuege-alle-ein =====
; fuegt alle uebergebenen Elemente in die Prio-Schlange ein
(define
  (fuege-alle-ein alle vor? ziel priows)
;;; --- fuege-einen-ein hier als innere Funktio
; fuegt ein Element in die Prio-Schlange ein
; benötigt das Praedikat vor?  und zielknoten
(define
  (fuege-einen-ein einer vor? priows)
  (cond
    ((null? priows) (list einer))
    ((vor? einer (first priows) ziel)
     (cons einer priows))
    (else
     (cons
      (first priows)
      (fuege-einen-ein einer vor? (rest priows))))
    )
  )
  (cond
    ((null? alle) priows)
    (else
     (fuege-alle-ein
      (rest alle)
      vor?
      ziel
      (fuege-einen-ein (first alle) vor? priows)))
    )
  )